# kTalk - NewsPro talkback addon

# Set the path to ktconfig.pl
# If it's in the same directory as npa_ktalk.pl, you may be able to leave
# this as is. If it is in another directory, or if you run into problems,
# change this to the absolute path to ktconfig.pl.
$ktconfigpath = 'ktconfig.pl';


# ------  NO EDITING REQURIED BELOW ---

require $ktconfigpath;

push(@Addons_Loaded, 'kTalk 1.0');
push(@Addons_SaveNews, 'ktalk_SaveNews');
push(@Addons_DisplaySubForm, 'ktalk_SubmitNews');
push(@Addons_loadND_3, 'ktalk_loadND_3');
push(@Addons_loadND_1, 'ktalk_loadND_1');
push(@Addons_RemoveNews2, 'ktalk_RemoveNews2');
push(@Addons_PageHandler, 'ktalk_PageHandler');
$Addons_List{'kTalk 1.0'} = ['npa_ktalk.pl', 'Allows users to post comments about your news items on a public talkback page. Created by KrYo.', 'http://amphibian.gagames.com/addon.cgi?ktalk&1.0'];

# sub for putting a dropdown in newspro submitnews section
sub ktalk_SubmitNews {
    push(@formfields, 'newsktalk');
    $FormFieldsName{'newsktalk'} = 'Create talkback page?';
    $FormFieldsCustom{'newsktalk'} = q~
    <select name="newsktalk"><option value="1" selected>Yes</option>
    <option value="0">No</option></select>~;
}


sub ktalk_SaveNews {

# Checking the dropdown
if ($newsktalk) {

	# Reading the template
	NPopen(INFILE,$talktmpl);
	my @templatePage = <INFILE>;
	close(INFILE);
	
	#condense page array into one scalar variable
	my $resultPage = join('', @templatePage);


  #getting a clean filename
   $filename = $snid; 
   $filename =~ s/[^0-9\,]//g; # Strip out anything other than number or comma from the news ID
   $filename .= $talkext; # Add .shtml to the end.

   NPopen(NEWFILE,">$talkdir/$filename");

   #Elvii code for getting formatted newsitems
   $newsdate = GetTheDate();
   require $ndisplaypl;
   &$ktnewssub;
   # The HTML is now in $newshtml

   # template search and replace
   $resultPage =~ s/<!--INSTRUCTIONS[\s\S]+?END INSTRUCTIONS-->//g; # in case people leave the instruction comment in
   $resultPage =~ s/<!--ktalk news-->/$newshtml/gi;
   $resultPage =~ s/<!--ktalk newsID-->/<input type="hidden" name="newsID" value="$newsid"><!--ktalk format 1-->/gi;
   $resultPage =~ s/<!--ktalk postURL-->/$postcgiurl/gi;

   print NEWFILE $resultPage;  
   close(NEWFILE);

}# end check
} #sub ending

sub ktalk_loadND_3 {
	opendir(KTALK, $talkdir);
 	my @talkdir = readdir(KTALK);
 	closedir(KTALK);
	
	my $ktdirentry;
	my $ktitemid;

	foreach $ktdirentry (@talkdir) {
		if ($ktdirentry =~ /([0-9\,]+)\Q$talkext\E/) {
			$ktitemid = $1;
			NPopen(KTFILE, "$talkdir/$ktdirentry");
			KTLOOP: while (<KTFILE>) {
				if (/<!--ktalk postnum:(\d+)-->/) {
					if ($NewsData[$NewsID{$ktitemid}]) {
						$NewsData[$NewsID{$ktitemid}]->{'ktalknum'} = $1;
						$NewsData[$NewsID{$ktitemid}]->{'ktalkURL'} = "$talkbaseurl/$ktitemid$talkext";
					}
					last KTLOOP;
					
				}
			}
			close(KTFILE);
		}
	}
}

sub ktalk_loadND_1 {
	push(@ffield_add, 'ktalknum', 'ktalkURL');
	$ktalknum = '';
	$ktalkURL = '';
}

sub ktalk_RemoveNews2 {
	if ($ktalknum && $up == 3) {
		print qq~
		<a href="$scripturl?ktalkremove$newsid">Remove Comments</a>
		~;
	}
}

sub ktalk_PageHandler {
	if (query_string() =~ /ktalkremove([\d\,]+)/) {
		ktalk_RemoveComments1($1);
		exit;
	}
	if (query_string() =~ /ktalkremovesave([\d\,]+)/) {
		ktalk_RemoveComments2($1);
		exit;
	}
}

sub ktalk_RemoveComments1 {
	my $itemID = shift;
	NPHTMLHead("Remove Comments");
	my $kfp = "$talkdir/$itemID$talkext";
	NPopen('KFILE', $kfp);
	my @kfcontents = <KFILE>;
	close(KFILE);
	my $kfc = join('', @kfcontents);
	unless ($kfc =~ /\Q<!--ktalk format 1-->\E/) {
		print qq~
		This comment page was created by an old version of kTalk, and comments cannot be removed from this page.
		~;
		NPHTMLFoot();
		exit;
	}
	print qq~<form action="$scripturl?ktalkremovesave$itemID" method="POST">~;
	my $commentID;
	my $fullcomment;
	my $commenttext;
	while ($kfc =~ /\Q<!--ktalk start_item \E([\d\-]+) \Q-->\E([\s\S]+?)\Q<!--ktalk end_item \E\1 -->/g) {
		$commentID = $1;
		$fullcomment = $2;
		unless ($fullcomment =~ /\Q<!--ktalk start_comment-->\E([\S\s]+?)\Q<!--ktalk end_comment-->\E/) {
			NPdie("Parsing error; comment file appears to be invalid.");
		}
		$commenttext = $1;
		print qq~
		$commenttext<br>Keep: <input type="radio" name="ktk--$commentID" value="keep" checked>
		Remove: <input type="radio" name="ktk--$commentID" value="remove"><hr width="95%" noshade>
		~;
	}
	print qq~
	<br><input type="submit" name="submit" value="Submit"></form>
	~;
	NPHTMLFoot();
}

sub ktalk_RemoveComments2 {
	my $itemID = shift;
	NPHTMLHead("Remove Comments");
	my $kfp = "$talkdir/$itemID$talkext";
	NPopen('KFILE', $kfp);
	my @kfcontents = <KFILE>;
	close(KFILE);
	my $kfc = join('', @kfcontents);
	unless ($kfc =~ /\Q<!--ktalk format 1-->\E/) {
		print qq~
		This comment page was created by an old version of kTalk, and comments cannot be removed from this page.
		~;
		NPHTMLFoot();
		exit;
	}	
	$kfc =~ /<!--ktalk postnum:(\d+)-->/;
	my $ktpostnum = $1;
	my $kkeynum;
	foreach $kkeynum (keys %in) {
		if ($kkeynum =~ /ktk--([\d\-]+)/) {
			if ($in{$kkeynum} eq "remove") {
				$kfc =~ s/\Q<!--ktalk start_item \E$1 -->[\s\S]+?\Q<!--ktalk end_item \E$1 -->//;
				$ktpostnum--;
			}
		}
	}
	$kfc =~ s/<!--ktalk postnum:(\d+)-->/<!--ktalk postnum:$ktpostnum-->/;
	NPopen('KFILE', ">$kfp");
	print KFILE $kfc;
	close(KFILE);
	print qq~
	Any comments which you chose to remove have been removed. They have already been removed from the comments page,
	however the comment count on your news page will not be updated until the news is built.
	~;
	NPHTMLFoot();
}
1;
